package com.bwie.Filter;


import com.bwie.config.LoginUserMap;
import com.bwie.domian.UserInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.charset.StandardCharsets;


@Slf4j
//注册到容器中
@Component
//1、实现Filter，然后重写init，doFilter，destroy方法
public class TokenFilter implements Filter {




    String WHILE_LIST="/login";
    String TOKEN_USER_KEY="token:user:";


    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
        Filter.super.init(filterConfig);
    }


    //过滤方法
    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        //先将其转成HttpServletRequest
        HttpServletRequest request=(HttpServletRequest) servletRequest;

        String requestURI = request.getRequestURI();
        //如果不在白名单中，则检测token是否正常
        if(!WHILE_LIST.contains(requestURI)){

            //获取请求头的参数
            String token = request.getHeader("token");
            if(token == null || token.length() == 0){
                resp(servletResponse,"账号未登录");
                return;
            }

            //从redis中获取token是否存在，是否过期
            UserInfo userInfo = LoginUserMap.get(token);
            if(userInfo == null){
                resp(servletResponse,"账号未登录");
                return;
            }

        }

        filterChain.doFilter(servletRequest, servletResponse);
    }



    @Override
    public void destroy() {
        Filter.super.destroy();
    }


    //相应方法封装
    private void resp(ServletResponse servletResponse,String msg) throws IOException {
        HttpServletResponse response=(HttpServletResponse) servletResponse;
        ServletOutputStream outputStream = response.getOutputStream();
        response.setStatus(401);
        response.setContentType("application/json");
        outputStream.write(msg.getBytes(StandardCharsets.UTF_8));
    }
}

