package com.bwie.aop;

import lombok.extern.log4j.Log4j2;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.stereotype.Component;

@Log4j2
@Aspect
@Component
public class RepeatSubmit {

    private final ThreadLocal<String> threadLocal=new ThreadLocal<>();

    @Pointcut("@annotation(com.bwie.aop.RepeatEnum)")
    private void pointcut(){}

    @Before("pointcut()")
    public void bef(){
        log.info("切面  -前");
    }

    @After("pointcut()")
    public void aft(){
        log.info("切面  -后");
    }
}
