package com.bwie.controller;

import com.bwie.aop.RepeatEnum;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.HashSet;
import java.util.Set;

@Log4j2
@RestController
@RequestMapping("/test")
public class TestController {

    @Autowired
    private HttpServletRequest request;

    private final Set<String> set=new HashSet<>();

    private static final String apiTemplate="%s:%s:%s";

    @RepeatEnum
    @PostMapping
    public String post(@RequestHeader("token") String token, @RequestBody String str){
        String format = String.format(apiTemplate, token, request.getRequestURI(), str);
        log.info("提交唯一标识：{}",format);
        //用户+请求+内容
       try {
           if (set.contains(format)){
               return "重复提交";
           }
           set.add(format);
           log.info("接收到请求：{}",str);
           Thread.sleep(5000);
           return "请求成功";
       } catch (InterruptedException e) {
               throw new RuntimeException(e);
       }finally {
           set.remove(format);
       }
    }
}
